#ifndef _FATFS_CONF_H
#define _FATFS_CONF_H

#include "ff.h"
#include "interface.h"
#include "stm32f4xx.h"

extern OS_EVENT *sd_mutex;

struct FileDate // STM32 是小端 ,我觉得说应该找不到大端的cpu吧。。。
{
    uint16_t Day   : 5;
    uint16_t Month : 4;
    uint16_t Year  : 7;
};
struct FileTime // STM32 是小端 ,我觉得说应该找不到大端的cpu吧。。。
{
    uint16_t Sec  : 5;
    uint16_t Min  : 6;
    uint16_t Hour : 5;
};

extern FATFS FatFs[_VOLUMES];
extern FIL   file_object;      /* 文件对象           4132字节*/
void         fatfs_init(void); // 文件系统初始化
#endif